include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CellMap_

ColumnCount equ 12
FloorCount equ 4
ColumnsPerByte equ 2
FloorHeight equ 4
ColumnWidth equ 2

Cell_Space equ 0
Cell_LowerMask equ 3
Cell_CrackedFloor equ 1
Cell_HardFloor equ 3
Cell_LadderDown equ 2
Cell_UpperMask equ 0ch
Cell_BrokenFloor equ 4
Cell_LadderUp equ 8
Cell_Item equ 0ch


; ptr<byte> CellMapPtr(byte x, byte y);
cseg
CellMapPtr_: public CellMapPtr_
    push psw | push b
        ora a | rar
        mov c,a
        mov a,e
        add a ;*2
        add e ;*3
        add a ;*6
        mov l,a
        mvi h,0
        mvi b,0
        dad b
        lxi b,CellMap_
        dad b
    pop b | pop psw
ret


; void MapToVVram();
cseg
MapToVVram_Row:
    mov m,e | inx h
    mov m,d
    mov a,l | adi VVramWidth-1 | mov l,a
    mov a,h | aci 0 | mov h,a
ret    
MapToVVram_Rows:
    do
        call MapToVVram_Row
        dcr b
    while nz | wend
ret
MapToVVram_: public MapToVVram_
    push psw | push h | push d | push b
        lxi h,VVram_
        lxi d,CellMap_
        mvi c,FloorCount
        do
            mvi b,ColumnCount/ColumnsPerByte
            do
                push b
                    ldax d | inx d
                    push d
                        mov c,a
                        mvi b,ColumnsPerByte
                        do
                            push b
                                mov a,c
                                ani Cell_UpperMask
                                cpi Cell_BrokenFloor
                                if z
                                    lxi d,Char_Space shl 8 or Char_Space
                                    mvi b,3
                                    call MapToVVram_Rows
                                    lxi d,(Char_CrackedFloor7) shl 8 or (Char_CrackedFloor6)
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                cpi Cell_Item
                                if z
                                    lxi d,Char_Space shl 8 or Char_Space
                                    call MapToVVram_Row
                                    lxi d,(Char_Item1) shl 8 or (Char_Item0)
                                    call MapToVVram_Row
                                    lxi d,(Char_Item3) shl 8 or (Char_Item2)
                                    call MapToVVram_Row
                                    lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                cpi Cell_LadderUp
                                if z
                                    lxi d,Char_Ladder1 shl 8 or Char_Ladder0
                                    mvi b,3
                                    call MapToVVram_Rows
                                    mov a,c
                                    ani Cell_LowerMask
                                    cpi Cell_LadderDown
                                    if nz
                                        lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                lxi d,Char_Space shl 8 or Char_Space
                                mvi b,2
                                call MapToVVram_Rows
                                
                                mov a,c
                                ani Cell_LowerMask
                                cpi Cell_LadderDown
                                if z
                                    lxi d,Char_Ladder1 shl 8 or Char_Ladder0
                                    mvi b,2
                                    call MapToVVram_Rows
                                    jmp nextColumn
                                endif
                                lxi d,Char_Space shl 8 or Char_Space
                                call MapToVVram_Row

                                mov a,c
                                ani Cell_LowerMask
                                cpi Cell_CrackedFloor
                                if z
                                    lxi d,(Char_CrackedFloor1) shl 8 or (Char_CrackedFloor0)
                                else
                                    cpi Cell_HardFloor
                                    if z
                                        lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                endif
                                call MapToVVram_Row

                                nextColumn:
                                lxi d,-VVramWidth*FloorHeight+ColumnWidth
                                dad d
                            pop b
                            mov a,c
                            rar | rar | rar | rar
                            ani $0f
                            mov c,a
                            dcr b
                        while nz | wend
                    pop d
                pop b
                dcr b
            while nz | wend
                                                _deb:public _deb
            push d
                lxi d,VVramWidth*FloorHeight-ColumnCount*ColumnWidth
                dad d
            pop d
            dcr c
        while nz | wend
    pop b | pop d | pop h | pop psw
ret
